library SIMD_LIB;

{$R *.res}

procedure iterate_SSE(var n, n2, n3, n4: integer; a, a2, a3, a4, b, re, re2, re3, re4, im, cnst: single; max2: integer); assembler; stdcall;
asm
        db $90,$90,$90,$90
        push ebx
        push edi
        push esi

        lea eax,a
        db $0F,$10,$10           /// movups xmm2,[eax]

        lea edx,b
        db $F3,$0F,$10,$1A       /// movss xmm3,[edx]
        db $0F,$C6,$DB,$00       /// shufps xmm3,xmm3,0

        lea eax,re
        db $0F,$10,$00           /// movups xmm0,[eax]

        lea edx,cnst
        db $F3,$0F,$10,$22       /// movss xmm4,[edx]
        db $0F,$C6,$E4,$00       /// shufps xmm4,xmm4,0

        lea eax,im
        db $F3,$0F,$10,$08       /// movss xmm1,[eax]
        db $0F,$C6,$C9,$00       /// shufps xmm1,xmm1,0

        db $0F,$28,$E8           /// movaps xmm5,xmm0
        db $0F,$59,$ED           /// mulps xmm5,xmm5

        db $0F,$28,$F1           /// movaps xmm6,xmm1
        db $0F,$59,$F6           /// mulps xmm6,xmm6

        xor edx,edx
        xor eax,eax
        xor ecx,ecx
        xor ebx,ebx
        xor esi,esi
 @iter:
        db $0F,$59,$C8           /// mulps xmm1,xmm0
        db $0F,$5C,$EE           /// subps xmm5,xmm6
        db $0F,$58,$C9           /// addps xmm1,xmm1
        db $0F,$58,$EA           /// addps xmm5,xmm2
        db $0F,$58,$CB           /// addps xmm1,xmm3
        db $0F,$28,$F1           /// movaps xmm6,xmm1
        db $0F,$59,$F6           /// mulps xmm6,xmm6
        db $0F,$28,$C5           /// movaps xmm0,xmm5
        db $0F,$59,$ED           /// mulps xmm5,xmm5
        db $0F,$28,$FD           /// movaps xmm7,xmm5
        db $0F,$58,$FE           /// addps xmm7,xmm6
        db $0F,$C2,$FC,$06       /// cmpnleps xmm7,xmm4
        inc edx
        db $0F,$50,$FF           /// movmskps edi,xmm7
        test edi,1
        db $0F,$44,$C2           /// cmovz eax,edx
        test edi,2
        db $0F,$44,$CA           /// cmovz ecx,edx
        test edi,4
        db $0F,$44,$DA           /// cmovz ebx,edx
        test edi,8
        db $0F,$44,$F2           /// cmovz esi,edx

        cmp edi,15
        je @end
        cmp edx,max2
        jb @iter
 @end:
        mov edi,[n]
        inc eax
        mov [edi],eax
        mov edi,[n2]
        inc ecx
        mov [edi],ecx
        mov edi,[n3]
        inc ebx
        mov [edi],ebx
        mov edi,[n4]
        inc esi
        mov [edi],esi

        pop esi
        pop edi
        pop ebx
end;


procedure iterate_3DNOW(var n, n2: integer; a, a2, b, re, re2, im, cnst: single; max2: integer); assembler; stdcall;
asm
        db $90,$90,$90,$90
        push ebx
        push esi
        db $0F,$0E               /// femms

        lea eax,a
        db $0F,$6F,$10           /// movq mm2,qword ptr [eax]

        lea edx,b
        db $0F,$6E,$1A           /// movd mm3,dword ptr [edx]
        db $0F,$62,$DB           /// punpckldq mm3,mm3

        lea eax,re
        db $0F,$6F,$00           /// movq mm0,qword ptr [eax]

        lea edx,cnst
        db $0F,$6E,$22           /// movd mm4,dword ptr [edx]
        db $0F,$62,$E4           /// punpckldq mm4,mm4

        lea eax,im
        db $0F,$6E,$08           /// movd mm1,dword ptr [eax]
        db $0F,$62,$C9           /// punpckldq mm1,mm1

        db $0F,$6F,$E8           /// movq mm5,mm0
        db $0F,$0F,$ED,$B4       /// pfmul mm5,mm5

        db $0F,$6F,$F1           /// movq mm6,mm1
        db $0F,$0F,$F6,$B4       /// pfmul mm6,mm6

        mov edx,[max2]
        mov eax,[n]
        mov ecx,[n2]
        mov [eax],edx
        mov [ecx],edx
        mov esi,[max2]
        xor edx,edx


 @iter:
        db $0F,$0F,$C8,$B4       /// pfmul mm1,mm0
        db $0F,$0F,$EE,$9A       /// pfsub mm5,mm6
        db $0F,$0F,$C9,$9E       /// pfadd mm1,mm1
        db $0F,$0F,$EA,$9E       /// pfadd mm5,mm2
        db $0F,$0F,$CB,$9E       /// pfadd mm1,mm3
        db $0F,$6F,$F1           /// movq mm6,mm1
        db $0F,$6F,$C5           /// movq mm0,mm5
        db $0F,$0F,$ED,$B4       /// pfmul mm5,mm5
        db $0F,$0F,$F6,$B4       /// pfmul mm6,mm6
        db $0F,$6F,$FD           /// movq mm7,mm5
        db $0F,$0F,$FE,$9E       /// pfadd mm7,mm6
        db $0F,$66,$FC           /// pcmpgtd mm7,mm4
        inc edx
        db $0F,$73,$D7,$18       /// psrlq mm7,24
        db $0F,$7E,$FB           /// movd ebx,mm7
        cmp bl,$FF
        jz @okfirst

@back1:
        cmp bh,$FF
        jz @oksecond

@back2: cmp edx,esi
        jb @iter
        jmp @end

@okfirst:
        mov [eax],edx
        mov eax,ecx
        jmp @back1

@oksecond:
        mov [ecx],edx
        mov ecx,eax
        cmp bx,$FFFF
        jne @back2
 @end:
        db $0F,$0E               /// femms
        pop esi
        pop ebx
end;


procedure iterate_SSE2(var n, n2: integer; a, a2, b, re, re2, im, cnst: double; max2: integer); assembler; stdcall;
asm

        push ebx
        push edi
        push esi
        
        lea eax,a
        db $66,$0F,$10,$10            /// movupd xmm2,[eax]

        lea edx,b
        db $F2,$0F,$10,$1A           /// movsd xmm3,[edx]
        db $66,$0F,$C6,$DB,$00       /// shufpd xmm3,xmm3,0

        lea eax,re
        db $66,$0F,$10,$00           /// movupd xmm0,[eax]

        lea edx,cnst
        db $F2,$0F,$10,$22           /// movsd xmm4,[edx]
        db $66,$0F,$C6,$E4,$00       /// shufpd xmm4,xmm4,0

        lea eax,im
        db $F2,$0F,$10,$08           /// movsd xmm1,[eax]
        db $66,$0F,$C6,$C9,$00       /// shufpd xmm1,xmm1,0

        db $66,$0F,$28,$E8           /// movapd xmm5,xmm0
        db $66,$0F,$59,$ED           /// mulpd xmm5,xmm5

        db $66,$0F,$28,$F1           /// movapd xmm6,xmm1
        db $66,$0F,$59,$F6           /// mulpd xmm6,xmm6

        xor edx,edx
        xor eax,eax
        xor ecx,ecx
        xor ebx,ebx
        xor esi,esi
 @iter:
        db $66,$0F,$59,$C8           /// mulpd xmm1,xmm0
        db $66,$0F,$5C,$EE           /// subpd xmm5,xmm6
        db $66,$0F,$58,$C9           /// addpd xmm1,xmm1
        db $66,$0F,$58,$EA           /// addpd xmm5,xmm2
        db $66,$0F,$58,$CB           /// addpd xmm1,xmm3
        db $66,$0F,$28,$C5           /// movapd xmm0,xmm5
        db $66,$0F,$59,$ED           /// mulpd xmm5,xmm5
        db $66,$0F,$28,$F1           /// movapd xmm6,xmm1
        db $66,$0F,$59,$F6           /// mulpd xmm6,xmm6
        db $66,$0F,$28,$FD           /// movapd xmm7,xmm5
        db $66,$0F,$58,$FE           /// addpd xmm7,xmm6
        db $66,$0F,$C2,$FC,$06       /// cmpnlepd xmm7,xmm4
        inc edx
        db $66,$0F,$50,$FF           /// movmskpd edi,xmm7
        test edi,1
        db $0F,$44,$C2           /// cmovz eax,edx
        test edi,2
        db $0F,$44,$CA           /// cmovz ecx,edx

        cmp edi,3
        je @end
        cmp edx,max2
        jb @iter
 @end:
        mov edi,[n]
        inc eax
        mov [edi],eax
        mov edi,[n2]
        inc ecx
        mov [edi],ecx

        pop esi
        pop edi
        pop ebx
end;


function iterate_FPU(a, b, re, im, cnst: extended; max2: integer): integer; assembler; stdcall;
asm

        xor edx,edx
        fld  a
        fld  b
        fld  cnst
        fld  re
        fld st(0)
        fmul st(0),st(1)
        fld  im
        fld st(0)
        fmul st(1),st(0)
        fincstp
        fxch
        fdecstp
        mov ecx,[max2]

@iter:  fmul st,st(3)
        fadd st,st(0)
        fadd st,st(5)
        fincstp
        fsub st,st(1)
        fadd st,st(5)
        fst  st(2)
        fmul st,st(0)
        inc edx
        fst  st(6)
        fdecstp
        fst  st(2)
        fmul st(2),st
        fdecstp
        fadd st,st(3)
        fcomp st(5)
        fnstsw ax
        and ah,41H
        JZ @ok
        cmp edx,ecx
        jb @iter
@ok:
        fcompp
        fcompp
        fcompp
        fstp st(0)
        mov eax,edx
end;


exports
iterate_SSE,   //32bit * 4
iterate_3DNOW, //32bit * 2
iterate_SSE2,  //64bit * 2
iterate_FPU;   //80bit * 1

begin
end.
